#ifndef WRITEBACKPLUGIN_H
#define WRITEBACKPLUGIN_H


#include <QtCore/QObject>
#include<QFile>

#include<writeback_export.h>

#include <kpluginfactory.h>
#include <kpluginloader.h>

namespace Soprano {
clas Node;
}

namespace Nepomuk {

class NEPOMUKWRITEBACK_EXPORT WritebackPlugin : public QObject 
{
        Q_OBJECT

public:
        WritebackPlugin( QObject* parent );
        virtual ~WritebackPlugin();

Q_SIGNALS:
      
      void finished(); // to signal that writeback is finished
      
private:
  
       void finished( Nepomuk::WritebackPlugin* plugin );  // emited by plugin once plugin is done, can't be called directly must use emitfinished in public.

public Q_SLOTS:

        void Writeback( const File* file );

 protected:
    
         virtual void doWriteback( const File* file ); // its declared as virtual as subclasses will reimplement it based on what type of file it is.

protected Q_SLOTS:
 
  void emitFinished(); // emit finish signal by the subclass to clarify that writeback is over.
 
private:
        class Private;
        Private* const d;

    };

} // End namespace Nepomuk

 
#define NEPOMUK_EXPORT_ANNOTATION_PLUGIN( classname, libname )  \
K_PLUGIN_FACTORY(factory, registerPlugin<classname>();)     \
K_EXPORT_PLUGIN(factory(#libname))

#endif